/**
* @author Dirk Nordmann
* @date   14.01.2002
*/
package xml2rtf.templates;

import java.io.*;
import java.awt.*;
import java.util.Hashtable;

public class ConversionTemplate
{

public static final int LIST_NO = 0;
public static final int LIST_OL = 1;
public static final int LIST_UL = 2;
public static final int LIST_DL = 3;
public static final int ALIGN_LEFT = 0;
public static final int ALIGN_RIGHT = 1;
public static final int ALIGN_CENTER = 2;
public static final int LST_OFFSET = 500;
public static final int maxTwipsWidth = 9000;
public static final int leftMarginInTwips = 1418;
public static final int topMarginInTwips = 1701;
public static final int rightMarginInTwips = 1701;
public static final int bottomMarginInTwips = 1134;
public static final int paperWidthInTwips = 11907;
public static final int paperHeightInTwips = 16840;
public static Hashtable colorList;
   
static {
		colorList = new Hashtable();
        colorList.put("aliceblue", "F0F8FF");
        colorList.put("antiquewhite", "FAEBD7");
        colorList.put("aqua", "00FFFF");
        colorList.put("aquamarine", "7FFFD4");
        colorList.put("azure", "F0FFFF");
        colorList.put("beige", "F5F5DC");
        colorList.put("bisque", "FFE4C4");
        colorList.put("black", "0");
        colorList.put("blanchedalmond", "FFEBCD");
        colorList.put("blue", "0000FF");
        colorList.put("blueviolet", "8A2BE2");
        colorList.put("brown", "A52A2A");
        colorList.put("burlywood", "DEB887");
        colorList.put("cadetblue", "5F9EA0");
        colorList.put("chartreuse", "7FFF00");
        colorList.put("chocolate", "D2691E");
        colorList.put("coral", "FF7F50");
        colorList.put("cornflowerblue", "6495ED");
        colorList.put("cornsilk", "FFF8DC");
        colorList.put("crimson", "DC143C");
        colorList.put("cyan", "00FFFF");
        colorList.put("darkblue", "00008B");
        colorList.put("darkcyan", "008B8B");
        colorList.put("darkgoldenrod", "B8860B");
        colorList.put("darkgray", "A9A9A9");
        colorList.put("darkgreen", "6400");
        colorList.put("darkkhaki", "BDB76B");
        colorList.put("darkmagenta", "8B008B");
        colorList.put("darkolivegreen", "556B2F");
        colorList.put("darkorange", "FF8C00");
        colorList.put("darkorchid", "9932CC");
        colorList.put("darkred", "8B0000");
        colorList.put("darksalmon", "E9967A");
        colorList.put("darkseagreen", "8FBC8F");
        colorList.put("darkslateblue", "483D8B");
        colorList.put("darkslategray", "2F4F4F");
        colorList.put("darkturquoise", "00CED1");
        colorList.put("darkviolet", "9400D3");
        colorList.put("deeppink", "FF1493");
        colorList.put("deepskyblue", "00BFBF");
        colorList.put("dimgray", "696969");
        colorList.put("dodgerblue", "1E90FF");
        colorList.put("firebrick", "B22222");
        colorList.put("floralwhite", "FFFAF0");
        colorList.put("forestgreen", "228B22");
        colorList.put("fuchsia", "FF00FF");
        colorList.put("ghostwhite", "F8F8FF");
        colorList.put("gainsboro", "DCDCDC");
        colorList.put("gold", "FFD700");
        colorList.put("goldenrod", "DAA520");
        colorList.put("gray", "808080");
        colorList.put("green", "8000");
        colorList.put("greenyellow", "ADFF2F");
        colorList.put("honeydew", "F0FFF0");
        colorList.put("hotpink", "FF69B4");
        colorList.put("indianred", "CD5C5C");
        colorList.put("indigo", "4B0082");
        colorList.put("ivory", "FFFFF0");
        colorList.put("khaki", "F0E68C");
        colorList.put("lavender", "E6E6FA");
        colorList.put("lavenderblush", "FFF0F5");
        colorList.put("lawngreen", "7CFC00");
        colorList.put("lemonchiffon", "FFFACD");
        colorList.put("lightblue", "ADD8E6");
        colorList.put("lightcoral", "F08080");
        colorList.put("lightcyan", "E0FFFF");
        colorList.put("lightgoldenrodyellow", "FAFAD2");
        colorList.put("lightgreen", "90EE90");
        colorList.put("lightgrey", "D3D3D3");
        colorList.put("lightpink", "FFB6C1");
        colorList.put("lightsalmon", "FFA07A");
        colorList.put("lightseagreen", "20B2AA");
        colorList.put("lightskyblue", "87CEFA");
        colorList.put("lightslategray", "778899");
        colorList.put("lightsteelblue", "B0C4DE");
        colorList.put("lightyellow", "FFFFE0");
        colorList.put("lime", "00FF00");
        colorList.put("limegreen", "32CD32");
        colorList.put("linen", "FAF0E6");
        colorList.put("magenta", "FF00FF");
        colorList.put("maroon", "800000");
        colorList.put("mediumaquamarine", "66CDAA");
        colorList.put("mediumblue", "0000CD");
        colorList.put("mediumorchid", "BA55D3");
        colorList.put("mediumpurple", "9370DB");
        colorList.put("mediumseagreen", "3CB371");
        colorList.put("mediumslateblue", "7B68EE");
        colorList.put("mediumspringgreen", "00FA9A");
        colorList.put("mediumturquoise", "48D1CC");
        colorList.put("mediumvioletred", "C71585");
        colorList.put("midnightblue", "191970");
        colorList.put("mintcream", "F5FFFA");
        colorList.put("mistyrose", "FFE4E1");
        colorList.put("moccasin", "FFE4B5");
        colorList.put("navajowhite", "FFDEAD");
        colorList.put("navy", "80");
        colorList.put("oldlace", "FDF5E6");
        colorList.put("olive", "808000");
        colorList.put("olivedrab", "6B8E23");
        colorList.put("orange", "FFA500");
        colorList.put("orangered", "FF4500");
        colorList.put("orchid", "DA70D6");
        colorList.put("palegoldenrod", "EEE8AA");
        colorList.put("palegreen", "98FB98");
        colorList.put("paleturquoise", "AFEEEE");
        colorList.put("palevioletred", "DB7093");
        colorList.put("papayawhip", "FFEFD5");
        colorList.put("peachpuff", "FFDAB9");
        colorList.put("peru", "CD853F");
        colorList.put("pink", "FFC0CB");
        colorList.put("plum", "DDA0DD");
        colorList.put("powderblue", "B0E0E6");
        colorList.put("purple", "800080");
        colorList.put("red", "FF0000");
        colorList.put("rosybrown", "BC8F8F");
        colorList.put("royalblue", "41690");
        colorList.put("saddlebrown", "8B4513");
        colorList.put("salmon", "FA8072");
        colorList.put("sandybrown", "F4A460");
        colorList.put("seagreen", "2E8B57");
        colorList.put("seashell", "FFF5EE");
        colorList.put("sienna", "A0522D");
        colorList.put("silver", "C0C0C0");
        colorList.put("skyblue", "87CEEB");
        colorList.put("slateblue", "6A5ACD");
        colorList.put("slategray", "708090");
        colorList.put("snow", "FFFAFA");
        colorList.put("springgreen", "00FF7F");
        colorList.put("steelblue", "4682B4");
        colorList.put("tan", "D2B48C");
        colorList.put("teal", "8080");
        colorList.put("thistle", "D8BFD8");
        colorList.put("tomato", "FF6347");
        colorList.put("turquoise", "40E0D0");
        colorList.put("violet", "EE82EE");
        colorList.put("wheat", "F5DEB3");
        colorList.put("white", "FFFFFF");
        colorList.put("whitesmoke", "F5F5F5");
        colorList.put("yellow", "FFFF00");
        colorList.put("yellowgreen", "9ACD32");
		}
		
    public static int decodeColor(String s)
    {
        if(s.startsWith("#"))
        {
            try
            {
                return Integer.parseInt(s.substring(1).trim(), 16);
            }
            catch(NumberFormatException _ex)
            {
                System.out.println("[decodeColor]: WARNUNG - ungltiger Farbwert: " + s );
            }
        } else
        {
            String s1 = (String)colorList.get(s.toLowerCase());
            if(s1 != null)
                return Integer.parseInt(s1, 16);
            else
                return decodeColor("#" + s);
        }
        return 0;
    }
   
}