###################################################################################################
# _objinputs.py
#
# Implementation of class ObjInputs (see below).
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
###################################################################################################

# Imports.
from Globals import HTMLFile
import string
import urllib
import time
# Product Imports.
import _globals


###################################################################################################
###################################################################################################
###
###   O B J E C T   I N P U T S
###
###################################################################################################
###################################################################################################
class ObjInputs:

  # ---------------------------------------------------------------------------------------------
  #  Richtext-Editor
  # ---------------------------------------------------------------------------------------------
  richedit_html = HTMLFile('rte/dtml/richedit', globals())
  rte_browse_files_html = HTMLFile('rte/dtml/rte_browse_files', globals())
  rte_browse_images_html = HTMLFile('rte/dtml/rte_browse_images', globals())
  rte_dlg_ins_image_html = HTMLFile('rte/dtml/rte_dlg_ins_image', globals())
  rte_dlg_ins_link_html = HTMLFile('rte/dtml/rte_dlg_ins_link', globals())
  rte_dlg_ins_table_html = HTMLFile('rte/dtml/rte_dlg_ins_table', globals())
  rte_dlg_ins_char_html = HTMLFile('rte/dtml/rte_dlg_ins_char', globals())
  rte_color_picker_html = HTMLFile('rte/dtml/rte_color_picker', globals())
  # JavaScript
  rte_js = HTMLFile('rte/dtml/rte_js', globals())
  rte_toolbar_js = HTMLFile('rte/dtml/rte_toolbar_js', globals())
  # VBScript
  rte_styles_vbs = HTMLFile('rte/dtml/rte_styles_vbs', globals())
  # Cascading StyleSheets
  rte_css = HTMLFile('rte/dtml/rte_css', globals())
  rte_syntax_css = HTMLFile('rte/dtml/rte_syntax_css', globals())

  # ---------------------------------------------------------------------------------------------
  #  ObjInputs.getDisabledText
  # ---------------------------------------------------------------------------------------------
  def getDisabledText(self, size, value):
    html = ''
    html = html + '<font class="form-element">'
    s_value = ''
    if value is not None:
      if type(value) is type([]):
        count = 0
      	for item in value:
          s_value = s_value + '%s<br>'%_globals.html_quote(item)
          count = count + 1
      else:
        s_value = s_value + '%s'%_globals.html_quote(value)
    for i in range(len(s_value),size+2):
      s_value = s_value + '&nbsp;'
    html = html + s_value
    html = html + '</font>'
    return html

  # ---------------------------------------------------------------------------------------------
  #  ObjInputs.getUrlInput:
  #
  #	@param fmName
  #	@param elName
  #	@param elTextName
  #	@param value
  #	@param enabled
  #	@param REQUEST
  #	@return String
  # ---------------------------------------------------------------------------------------------
  def getUrlInput(self, fmName, elName, elTextName, value, enabled, REQUEST, css='form-element'):
    html = ''
    html = html + '<div class="%s">'%css
    html = html + self.getTextInput(fmName,elName,15,value,'text',enabled,REQUEST,css)
    html = html + '<input '
    html = html + ' class="%s"'%css
    html = html + ' type="submit"'
    html = html + ' name="btn"'
    html = html + ' value="..."' 
    html = html + ' onclick="return browseObjsBtnClick(\'%s\',\'%s\',\'%s\')"'%(fmName,elName,elTextName)
    html = html + '</div>'
    ref_obj = self.getLinkObj(value,REQUEST)
    if ref_obj is not None:
      html = html + '<div class="form-small">'
      html = html + '<b>%s</b>: %s'%(self.getLangStr('ATTR_TARGET',REQUEST['manage_lang']),ref_obj.f_breadcrumbs(objectPathElements=ref_obj.breadcrumbs_obj_path(),no_icon=1,lang=REQUEST['lang'],manage_lang=REQUEST['manage_lang'],REQUEST=REQUEST))
      html = html + '</div>'
    return html


  # ---------------------------------------------------------------------------------------------
  # 	getDateTimeInput:
  #
  #	@param fmName
  #	@param elName
  #	@param value
  #	@param enabled
  #	@param REQUEST
  #	@return String
  # ---------------------------------------------------------------------------------------------
  def getDateTimeInput(self, fmName, elName, size, value, enabled, fmt_str, REQUEST, css='form-element'):
    manage_lang = REQUEST['manage_lang']
    if value is not None and type(value) != type(''):
      value = self.getLangFmtDate(value,manage_lang,fmt_str)
    if value is not None and self.parseLangFmtDate(value,manage_lang,fmt_str) is None:
      value = ''
    html = ""
    if enabled:
      html = html + '<table cellspacing="0" cellpadding="0" border="0">\n'
      html = html + '<tr valign="middle">\n'
      html = html + '<td title="%s">'%(self.getLangStr(fmt_str,manage_lang))
      html = html + self.getTextInput(fmName,elName,size,value,'text',enabled,REQUEST,css)
      html = html + '</td>\n'
      html = html + '<td>'
      html = html + '<a href="javascript:calendarBtnClick(\'%s\',\'%s\',\'%s\')" class="button">'%(fmName,elName,manage_lang)
      html = html + '<img src="%sbtn_kalender.gif" alt="%s..." border="0" align="absmiddle">'%(self.MISC_ZMS,self.getLangStr('ATTR_CALENDAR',manage_lang))
      html = html + '</a>'
      html = html + '</td>\n'
      html = html + '<td valign="middle">'
      html = html + '&nbsp;'
      html = html + '</td>\n'
      html = html + '</tr>\n'
      html = html + '</table>\n'
    else:
      html = self.getDisabledText(size,value)
    return html

  # ---------------------------------------------------------------------------------------------
  # 	getDateInput:
  #
  #	@param fmName
  #	@param elName
  #	@param value
  #	@param enabled
  #	@param REQUEST
  #	@return String
  # ---------------------------------------------------------------------------------------------
  def getDateInput(self, fmName, elName, value, enabled, REQUEST, css='form-element'):
    size = 8
    fmt_str = 'DATE_FMT'
    return self.getDateTimeInput(fmName,elName,size,value,enabled,fmt_str,REQUEST)

  # ---------------------------------------------------------------------------------------------
  # 	getPasswordInput:
  #
  #	@param fmName
  #	@param elName
  #	@param size
  #	@param value
  #	@param enabled
  #	@return String
  # ---------------------------------------------------------------------------------------------
  def getPasswordInput(self, fmName, elName, size=15, value="", enabled=1, REQUEST=None, css='form-element'):
    return self.getTextInput(fmName,elName,size,value,"password",enabled,REQUEST,css)

  # ---------------------------------------------------------------------------------------------
  # 	getTextInput:
  #
  #	@param fmName
  #	@param elName
  #	@param size
  #	@param value (optional)
  #	@param type (optional: "text" or "password")
  #	@return String
  # ---------------------------------------------------------------------------------------------
  def getTextInput(self, fmName, elName, size=15, value='', type='text', enabled=1, REQUEST=None, css='form-element'):
    html = ''
    if enabled:
      html = html + '<font class="%s">'%css
      html = html + '<input '
      html = html + ' class="%s"'%css
      html = html + ' type="%s"'%type
      html = html + ' name="%s"'%elName
      if value is not None:
        html = html + ' value="%s"'%_globals.html_quote(value)
      html = html + ' size="%i"'%size # Netscape Navigator
      html = html + ' style="font-style:normal; width=%ipx"'%(size*12) # Internet Explorer
      html = html + '>'
      html = html + '</font>'
    else:
      html = self.getDisabledText(size,value)
    return html

  # ---------------------------------------------------------------------------------------------
  # 	getSelect:
  #
  #	@param fmName
  #	@param elName
  #	@param value
  #	@param options
  #	@param multiple
  #	@param enabled
  #	@param REQUEST
  #	@return String
  # ---------------------------------------------------------------------------------------------
  def getSelect(self, fmName, elName, value, options, multiple, enabled, REQUEST, css='form-element'):
    html = ''
    if enabled:
      html = html + '<font class="%s">'%css
      html = html + '<select'
      html = html + ' class="%s"'%css
      html = html + ' name="%s"'%elName
      if multiple:
        html = html + ' multiple="multiple"'
        if len(options) > 5:
          html = html + ' size="5"'
        else:
          html = html + ' size="%i"'%len(options)
      html = html + '>'
      for option in options:
        html = html + '\n<option'
        html = html + ' value="%s"'%str(option[0])
        if str(option[0]) == str(value) or \
           (type(value) is type([]) and (option[0] in value or str(option[0]) in value)):
          html = html + ' selected="selected"'
        html = html + '>%s</option>'%str(option[1])
      html = html + '\n</select>'
      html = html + '</font>'
    else:
      for option in options:
        if str(option[0]) == str(value) or \
           (type(value) is type([]) and (option[0] in value or str(option[0]) in value)):
          html = html + '%s\n'%str(option[1])
      html = self.getDisabledText(20,html)
    return html

  # ---------------------------------------------------------------------------------------------
  # 	getCheckbox:
  #
  #	@param fmName
  #	@param elName
  #	@param value
  #	@param valueChecked
  #	@param enabled
  #	@param REQUEST
  #	@return String
  # ---------------------------------------------------------------------------------------------
  def getCheckbox(self, fmName, elName, value, valueChecked, enabled, REQUEST):
    html = ''
    if enabled:
      html = html + '<input '
      html = html + ' class="form-element"'
      html = html + ' type="checkbox"'
      html = html + ' name="%s"'%elName
      if str(value) == str(valueChecked):
        html = html + ' checked="checked"'
      html = html + ' value="%s"'%_globals.html_quote(valueChecked)
      html = html + '>'
    else:
      html = html + '<img alt="" border="0"'
      if str(value) == str(valueChecked):
        html = html + ' src="%s/checkbox_disabled_checked.gif"'%self.MISC_ZMS
      else:
        html = html + ' src="%s/checkbox_disabled_unchecked.gif"'%self.MISC_ZMS
      html = html + '>'
    html = html + '<img src="%s/spacer.gif" alt="" border="0" width="1" height="20">'%self.MISC_ZMS
    return html
    
  # ---------------------------------------------------------------------------------------------
  # 	getTextArea:
  #
  #	@param fmName
  #	@param elName
  #	@param cols
  #	@param rows
  #	@param value
  #	@param enabled
  #	@param REQUEST
  #	@param css	CSS-Class
  #	@return String
  # ---------------------------------------------------------------------------------------------
  def getTextArea(self, fmName, elName, cols, rows, value, enabled, REQUEST, css='form-element', wrap='on'):
    html = ''
    if enabled:
      html = html + '<div class="%s">'%css
      html = html + '<textarea '
      html = html + ' class="%s"'%css
      html = html + ' name="%s"'%elName
      html = html + ' cols="%i"'%cols # Netscape Navigator
      html = html + ' style="font-style:normal; width=%ipx"'%(cols*12) # Internet Explorer
      html = html + ' rows="%i"'%rows
      html = html + ' wrap="%s"'%wrap
      html = html + '>'
      if value is not None:
        if type(value) is type([]):
          for item in value:
            html = html + '%s\n'%_globals.html_quote(item)  
        else:
          html = html + '%s'%_globals.html_quote(value)
      html = html + '</textarea>'
      html = html + '</div>'
    else:
      html = self.getDisabledText(cols,value)
    return html

###################################################################################################